/*

40 PIN AVR Development Board
Sample Programs

This program demonstrate how you can control a DC motor.

You can run the motor in either clock wise, counter clock wise directions
or stop it at all.

The motor will start rotating and after a few seconds it will change its 
rotation direction. Then it will stop for few seconds.

Please see this link for details
http://extremeelectronics.co.in/avr40dev/docs/simple_single_motor.htm

Author
Avinash Gupta

NO PART OF THIS WORK CAN BE PUBLISHED OR COPIED EITHER IN ELECTRONIC
OR PRINTED FORM WITHOUT A WRITTEN PERMISSION FROM THE AUTHORS

COPYRIGHT 2008-2014
EXTREME ELECTRONICS
www.eXtremeElectronics.co.in

*/


#include <avr/io.h>
#include <util/delay.h>

#define MOTOR_PORT	PORTC
#define MOTOR_DDR	DDRC
#define MOTOR_PIN1	PC0
#define MOTOR_PIN2	PC1

void MotorInit();
void MotorCW();
void MotorCCW();
void MotorStop();

int main(void)
{
	MotorInit();
	
    while(1)
    {
        MotorCW();
		
		_delay_ms(3000);
		
		MotorCCW();
		
		_delay_ms(3000);
		
		MotorStop();
		
		_delay_ms(3000);
    }
}

void MotorInit()
{
	MotorStop();
	
	//Set MCU's i/o line to output mode
	MOTOR_DDR|=(1<<MOTOR_PIN1)|(1<<MOTOR_PIN2);
}

void MotorCW()
{
	MOTOR_PORT|=(1<<MOTOR_PIN1);	//Set PIN1 High
	MOTOR_PORT&=~(1<<MOTOR_PIN2);	//Set PIN2 Low
}

void MotorCCW()
{
	MOTOR_PORT&=~(1<<MOTOR_PIN1);	//Set PIN1 Low
	MOTOR_PORT|=(1<<MOTOR_PIN2);	//Set PIN2 High
}

void MotorStop()
{
	MOTOR_PORT&=~(1<<MOTOR_PIN1);	//Set PIN1 Low
	MOTOR_PORT&=~(1<<MOTOR_PIN2);	//Set PIN2 Low	
}